wxWidgets: wxMemoryOutputStream Class Reference

| Version: 3.0.2

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
wxMemoryOutputStream Class Reference
Streams

`#include <wx/mstream.h>`

Inheritance diagram for wxMemoryOutputStream:
[legend]

## Detailed Description

This class allows to use all methods taking a wxOutputStream reference to write to in-memory data.

Example:

wxMemoryOutputStream stream;
if (!my_wxImage.SaveFile(stream))
return;
// now we can access the saved image bytes:
wxStreamBuffer* theBuffer = stream.GetOutputStreamBuffer();
unsigned char byte;
if (theBuffer->Read(byte, 1) != 1)
return;
// ... do something with 'byte'...
// remember that ~wxMemoryOutputStream will destroy the internal
// buffer since we didn't provide our own when constructing it

##

Library: wxBase
Category: Streams

See Also
  wxStreamBuffer

## Public Member Functions
| wxMemoryOutputStream (void *data=NULL, size_t length=0)
| If data is NULL, then it will initialize a new empty buffer which will grow if required.
virtual | ~wxMemoryOutputStream ()
| Destructor.
size_t | CopyTo (void *buffer, size_t len) const
| Allows you to transfer data from the internal buffer of wxMemoryOutputStream to an external buffer.
wxStreamBuffer * | GetOutputStreamBuffer () const
| Returns the pointer to the stream object used as an internal buffer for this stream.
Public Member Functions inherited from wxOutputStream
| wxOutputStream ()
| Creates a dummy wxOutputStream object.
virtual | ~wxOutputStream ()
| Destructor.
virtual bool | Close ()
| Closes the stream, returning false if an error occurs.
virtual size_t | LastWrite () const
| Returns the number of bytes written during the last Write().
void | PutC (char c)
| Puts the specified character in the output queue and increments the stream position.
virtual wxFileOffset | SeekO (wxFileOffset pos, wxSeekMode mode=wxFromStart)
| Changes the stream current position.
virtual wxFileOffset | TellO () const
| Returns the current stream position.
virtual wxOutputStream & | Write (const void *buffer, size_t size)
| Writes up to the specified amount of bytes using the data of buffer.
wxOutputStream & | Write (wxInputStream &stream_in)
| Reads data from the specified input stream and stores them in the current stream.
bool | WriteAll (const void *buffer, size_t size)
| Writes exactly the specified number of bytes from the buffer.
Public Member Functions inherited from wxStreamBase
| wxStreamBase ()
| Creates a dummy stream object.
virtual | ~wxStreamBase ()
| Destructor.
wxStreamError | GetLastError () const
| This function returns the last error.
virtual wxFileOffset | GetLength () const
| Returns the length of the stream in bytes.
virtual size_t | GetSize () const
| This function returns the size of the stream.
virtual bool | IsOk () const
| Returns true if no error occurred on the stream.
virtual bool | IsSeekable () const
| Returns true if the stream supports seeking to arbitrary offsets.
void | Reset (wxStreamError error=wxSTREAM_NO_ERROR)
| Resets the stream state.
bool | operator! () const
| Returns the opposite of IsOk().

## Additional Inherited Members
Protected Member Functions inherited from wxOutputStream
size_t | OnSysWrite (const void *buffer, size_t bufsize)
| Internal function.

## Constructor & Destructor Documentation

wxMemoryOutputStream::wxMemoryOutputStream | ( | void * | data = `NULL`,
|  | size_t | length = `0`
| ) |  |

If data is NULL, then it will initialize a new empty buffer which will grow if required.

Warning
  If the buffer is created by wxMemoryOutputStream, it will be destroyed at the destruction of the stream.

virtual wxMemoryOutputStream::~wxMemoryOutputStream | ( |  | ) |
| virtual

Destructor.

If the buffer wasn't provided by the user, it will be deleted here.

## Member Function Documentation

size_t wxMemoryOutputStream::CopyTo | ( | void * | buffer,
|  | size_t | len
| ) |  | const

Allows you to transfer data from the internal buffer of wxMemoryOutputStream to an external buffer.

len specifies the size of the buffer.

wxStreamBuffer* wxMemoryOutputStream::GetOutputStreamBuffer | ( |  | ) | const

Returns the pointer to the stream object used as an internal buffer for this stream.